#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\toolbox.h>
#include <owl\buttonga.h>
#include <owl\dc.h>
#include <stdio.h>
#include <owl\gdiobjec.h>
#include <owl\opensave.h>
//#include <owl/validate.h>
#include <owl\dialog.h>
#include <owl\clipboar.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
//#include <owl/scroller.h>
#include "paint.rc"

struct TrBuf
{
char width[6];
char height[6];
}Buf1;

struct
{
char* file;
TColor* pal;
int line;
int style;
}Buf;

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};


class TCBar:public TToolBox
{
		public: TCBar(TWindow*parent,int nc,int nr):TToolBox(parent,nc,nr){};
		protected: void Paint(TDC&,BOOL,TRect&);
					  void EvLButtonDown(UINT,TPoint&p);
					  void EvRButtonDown(UINT,TPoint&p);
					  void EvLButtonDblClk(UINT,TPoint&p);
					  DECLARE_RESPONSE_TABLE(TCBar);
};

DEFINE_RESPONSE_TABLE1(TCBar,TToolBox)
	EV_WM_LBUTTONDOWN,
	EV_WM_RBUTTONDOWN,
	EV_WM_LBUTTONDBLCLK,
END_RESPONSE_TABLE;

void TCBar::EvLButtonDown(UINT,TPoint&p)
{
  int c=-1;
  for(int i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2)&&(p.y<24)) c=i;//2,24);
	}
  for(i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2+28)&&(p.y<24+28)) c=i+16;//2,24);
	}
  if(c>=0) Buf.pal[32]=Buf.pal[c];
  Invalidate();
}

void TCBar::EvRButtonDown(UINT,TPoint&p)
{
  int c=-1;
  for(int i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2)&&(p.y<24)) c=i;//2,24);
	}
  for(i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2+28)&&(p.y<24+28)) c=i+16;//2,24);
	}
  if(c>=0) Buf.pal[33]=Buf.pal[c];
  Invalidate();
}

void TCBar::EvLButtonDblClk(UINT,TPoint&p)
{
  int c=-1;
  for(int i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2)&&(p.y<24)) c=i;//2,24);
	}
  for(i=0;i<16;i++)
	{
	  if ((p.x>56+2+28*i)&&(p.x<56+24+28*i)&&(p.y>2+28)&&(p.y<24+28)) c=i+16;//2,24);
	}
  if(c>=0)
  {
  TChooseColorDialog::TData colorData;
	static TColor customColors[16] =
  { 0x010101L, 0x101010L, 0x202020L, 0x303030L,
	 0x404040L, 0x505050L, 0x606060L, 0x707070L,
	 0x808080L, 0x909090L, 0xA0A0A0L, 0xB0B0B0L,
	 0xC0C0C0L, 0xD0D0D0L, 0xE0E0E0L, 0xF0F0F0L
  };
  colorData.Flags = CC_FULLOPEN | CC_RGBINIT;
  if (c>=0) colorData.Color = Buf.pal[c];
  colorData.CustColors = customColors;
  TChooseColorDialog *dialog =new TChooseColorDialog (this, colorData);
  if (dialog->Execute()== IDOK)
  {
	 Buf.pal[c]=colorData.Color;
	 Invalidate();
  }
  }
}

void TCBar::Paint(TDC&dc,BOOL b,TRect&r)
{
  TToolBox::Paint(dc,b,r);
  dc.SelectObject(TPen(TColor::Black,1,PS_SOLID));
  for(int i=0;i<16;i++)
  {
	 dc.SelectObject(TBrush(Buf.pal[i]));
	 dc.Rectangle(56+2+28*i,2,56+24+28*i,24);
  }
  for(i=0;i<16;i++)
  {
	 dc.SelectObject(TBrush(Buf.pal[i+16]));
	 dc.Rectangle(56+2+28*i,2+28,56+24+28*i,24+28);
  }
  dc.SelectObject(TBrush(Buf.pal[33]));
  dc.Rectangle(20,20,20+24,20+24);
  dc.SelectObject(TBrush(Buf.pal[32]));
  dc.Rectangle(12,12,12+24,12+24);

};



//  
class TCWndw:public TWindow
{
	public: TCWndw(TWindow*parent,const char far*title);
	protected:	void EvLButtonDown(UINT,TPoint&point);
					void EvLButtonUp(UINT,TPoint&point);
					void EvMouseMove(UINT,TPoint&point);
					void EvRButtonDown(UINT,TPoint&point);
					void EvRButtonUp(UINT,TPoint&point);
					LRESULT WmChangeP(WPARAM Id,LPARAM);
					LRESULT WmNew(WPARAM,LPARAM);
					LRESULT WmOpen(WPARAM,LPARAM);
					LRESULT WmSave(WPARAM,LPARAM);
					LRESULT WmAtr(WPARAM,LPARAM);
					void SetupWindow();
					void Paint(TDC&DC,BOOL,TRect&);
					int idp;
					TPoint pp;
					int pressed;
					TBitmap *pic;
					DECLARE_RESPONSE_TABLE(TCWndw);
};
//  
TCWndw::TCWndw(TWindow*parent,const char far*title):TWindow(parent,title)
{
}

//   
DEFINE_RESPONSE_TABLE1(TCWndw,TWindow)
	EV_WM_LBUTTONDOWN,
	EV_WM_LBUTTONUP,
	EV_WM_MOUSEMOVE,
	EV_WM_RBUTTONDOWN,
	EV_WM_RBUTTONUP,
	EV_MESSAGE(WM_CHANGEP,WmChangeP),
	EV_MESSAGE(WM_NEW,WmNew),
	EV_MESSAGE(WM_OPEN,WmOpen),
	EV_MESSAGE(WM_SAVE,WmSave),
	EV_MESSAGE(WM_ATR,WmAtr),
END_RESPONSE_TABLE;

void TCWndw::SetupWindow()
{
  idp=1;
  pressed=false;
  TClientDC DC(HWindow);
  TRect rrr(0,0,256,256);
  TBrush b(TColor::White);
  TPen p(TColor::White,1,PS_SOLID);
  TMemoryDC mdc(DC);
  pic=new TBitmap(DC,rrr.Width(),rrr.Height(),FALSE);
  mdc.SelectObject(*pic);
  mdc.SelectObject(p);
  mdc.SelectObject(b);
  mdc.Rectangle(rrr);
  itoa(pic->Width(),Buf1.width,10);
  itoa(pic->Height(),Buf1.height,10);
  DC.BitBlt(0,0,rrr.Width(),rrr.Height(),mdc,0,0);
}



//  
class TWndw : public TDecoratedFrame
{
  public:	TWndw (TWindow *parent, const char far *title,TWindow *client);
				~TWndw ();
  protected:	TToolBox *tbox,*cbar;
					DECLARE_RESPONSE_TABLE(TWndw);
					void CmP(WPARAM Id);
					void CmNew();
					void CmOpen();
					void CmSave();
					void CmSaveAs();
					void CmAtr();
					void CmLine(WPARAM Id);
					void CmRc(WPARAM Id);
					void Paint(TDC&dc,BOOL,TRect&rect);
					TOpenSaveDialog::TData* FileData;

};

//  
TWndw::TWndw (TWindow *parent, const char far *title,TWindow *client):TDecoratedFrame(parent,title,client)
{
  Buf.file=new char[80];
  strcpy(Buf.file,"");
  Buf.pal=new TColor[34];
  Buf.pal[0]=TColor::Black;
  Buf.pal[1]=TColor(32,32,32);
  Buf.pal[2]=TColor(64,64,64);
  Buf.pal[3]=TColor(96,96,96);
  Buf.pal[4]=TColor::LtBlue;
  Buf.pal[5]=TColor::LtRed;
  Buf.pal[6]=TColor::LtGreen;
  Buf.pal[7]=TColor::LtMagenta;
  Buf.pal[8]=TColor::LtCyan;
  Buf.pal[9]=TColor::LtYellow;
  Buf.pal[10]=TColor(0,0,128);
  Buf.pal[11]=TColor(128,0,0);
  Buf.pal[12]=TColor(0,128,0);
  Buf.pal[13]=TColor(128,0,128);
  Buf.pal[14]=TColor(0,128,128);
  Buf.pal[15]=TColor(128,128,0);

  Buf.pal[16]=TColor::White;
  Buf.pal[17]=TColor(255-32,255-32,255-32);
  Buf.pal[18]=TColor(255-64,255-64,255-64);
  Buf.pal[19]=TColor(255-96,255-96,255-96);
  Buf.pal[20]=TColor(0,128,255);
  Buf.pal[21]=TColor(255,128,128);
  Buf.pal[22]=TColor(128,255,128);
  Buf.pal[23]=TColor(255,128,255);
  Buf.pal[24]=TColor(128,255,255);
  Buf.pal[25]=TColor(255,255,128);
  Buf.pal[26]=TColor(0,0,128+64);
  Buf.pal[27]=TColor(128+64,0,0);
  Buf.pal[28]=TColor(0,128+64,0);
  Buf.pal[29]=TColor(128+64,0,128+64);
  Buf.pal[30]=TColor(0,128+64,128+64);
  Buf.pal[31]=TColor(128+64,128+64,0);
  Buf.pal[32]=TColor::Black;
  Buf.pal[33]=TColor::White;
  Buf.line=1;
  Buf.style=0;
  AssignMenu(MENU_1);
  cbar=new TCBar(this,AS_MANY_AS_NEEDED,2);
  TButtonGadget *b;
  TSeparatorGadget *s;
  s=new TSeparatorGadget(28);
  cbar->Insert(*s);
//  s=new TSeparatorGadget(28);
//  cbar->Insert(*s);
/*  for(int i=0;i<16;i++)
  {
	 b=new TButtonGadget(BMP_CLR,CM_CHCOLOR+i);
	 cbar->Insert(*b);
  }
  s=new TSeparatorGadget(24);
  cbar->Insert(*s);
  s=new TSeparatorGadget(24);
  cbar->Insert(*s);
  for(i=0;i<16;i++)
  {
	 b=new TButtonGadget(BMP_CLR,CM_CHCOLOR+i+16);
	 cbar->Insert(*b);
  }*/

  tbox=new TToolBox(this);
  b=new TButtonGadget(BMP_LINE,CM_LINE,TButtonGadget::Exclusive,TRUE,TButtonGadget::Down);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_RECT,CM_RECT,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_ERA,CM_ERA,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_BID,CM_BID,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_PEN,CM_PEN,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_GET,CM_GET,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_ELL,CM_ELL,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_BR,CM_BR,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  s=new TSeparatorGadget(24);
  tbox->Insert(*s);
  s=new TSeparatorGadget(24);
  tbox->Insert(*s);
  b=new TButtonGadget(BMP_L,CM_L,TButtonGadget::Exclusive,TRUE,TButtonGadget::Down);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_L+1,CM_L+1,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_L+2,CM_L+2,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_L+3,CM_L+3,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);
  s=new TSeparatorGadget(24);
  tbox->Insert(*s);
  s=new TSeparatorGadget(24);
  tbox->Insert(*s);
  b=new TButtonGadget(BMP_RC,CM_RC,TButtonGadget::Exclusive,TRUE,TButtonGadget::Down);
  tbox->Insert(*b);
  b=new TButtonGadget(BMP_RC+1,CM_RC+1,TButtonGadget::Exclusive,TRUE,TButtonGadget::Up);
  tbox->Insert(*b);


  Insert(*tbox,TDecoratedFrame::Left);
  Insert(*cbar,TDecoratedFrame::Bottom);
  FileData=new TOpenSaveDialog::TData(OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,"Bitmap (*.bmp)|*.bmp|", 0, "", "bmp");
}

TWndw::~TWndw()
{
  delete tbox;
  delete cbar;
}

//   
DEFINE_RESPONSE_TABLE1(TWndw,TDecoratedFrame)
	EV_COMMAND_AND_ID(CM_LINE,CmP),
	EV_COMMAND_AND_ID(CM_RECT,CmP),
	EV_COMMAND_AND_ID(CM_ERA,CmP),
	EV_COMMAND_AND_ID(CM_BID,CmP),
	EV_COMMAND_AND_ID(CM_PEN,CmP),
	EV_COMMAND_AND_ID(CM_GET,CmP),
	EV_COMMAND_AND_ID(CM_ELL,CmP),
	EV_COMMAND_AND_ID(CM_BR,CmP),
	EV_COMMAND_AND_ID(CM_L,CmLine),
	EV_COMMAND_AND_ID(CM_L+1,CmLine),
	EV_COMMAND_AND_ID(CM_L+2,CmLine),
	EV_COMMAND_AND_ID(CM_L+3,CmLine),
	EV_COMMAND_AND_ID(CM_RC,CmRc),
	EV_COMMAND_AND_ID(CM_RC+1,CmRc),
	EV_COMMAND(CM_NEW,CmNew),
	EV_COMMAND(CM_OPEN,CmOpen),
	EV_COMMAND(CM_SAVE,CmSave),
	EV_COMMAND(CM_SAVEAS,CmSaveAs),
	EV_COMMAND(CM_ATR,CmAtr),
END_RESPONSE_TABLE;

//  
class TDlg:public TDialog
{
  protected:
	  TrBuf oldBuf;
  public:
	  TDlg(TWindow *parent, TResId resld);
  protected:
	  void SetupWindow();
	  BOOL CanClose();
	  void CmCancel();

	  DECLARE_RESPONSE_TABLE(TDlg);
};

DEFINE_RESPONSE_TABLE1(TDlg, TDialog)
  EV_COMMAND(IDCANCEL, CmCancel),
END_RESPONSE_TABLE;

TDlg::TDlg(TWindow *parent,TResId resId):TDialog(parent,resId)
{
TEdit *edit;
TValidator *valid;
edit=new TEdit(this,IDC_WIDTH,sizeof(&Buf1.width));
valid = new TFilterValidator("0-9");
edit->SetValidator(valid);
edit=new TEdit(this,IDC_HEIGHT,sizeof(&Buf1.height));
valid = new TFilterValidator("0-9");
edit->SetValidator(valid);
TransferBuffer=&Buf1;
TransferData(tdSetData);
}

void TDlg::SetupWindow()
{
  TDialog::SetupWindow();
  memcpy(&oldBuf, &Buf1, sizeof(TrBuf));
}

BOOL TDlg::CanClose()
{
  TDialog::CanClose();
  TransferData(tdGetData);
  if ((strlen(Buf1.width)==0)||(strlen(Buf1.height)==0))
  {
	 MessageBox(" "," ",MB_OK);
	 return false;
  } else
  {
  return TRUE;
  }
}

void TDlg::CmCancel()
{
  memcpy(&Buf1, &oldBuf, sizeof(oldBuf));
  TDialog::CmCancel();
}

void TWndw::Paint(TDC&,BOOL,TRect&)
{
//cbar->Invalidate();
}


//    
void TWndw::CmP(WPARAM Id)
{
  ClientWnd->PostMessage(WM_CHANGEP,Id-200,0);
}

void TWndw::CmLine(WPARAM Id)
{
Buf.line=Id-208;
}

void TWndw::CmRc(WPARAM Id)
{
Buf.style=Id-213;
}

void TWndw::CmAtr()
{
ClientWnd->PostMessage(WM_ATR,0,0);
}

LRESULT TCWndw::WmAtr(WPARAM,LPARAM)
{
  int w,h;
  TClientDC dc(HWindow);
  TDialog *dialog = new TDlg(this, DIALOG_1);
  int result = dialog->Execute();
  w=atoi(Buf1.width);
  h=atoi(Buf1.height);
  TBitmap *pic1=new TBitmap(dc,w,h,0);
  TMemoryDC mdc(dc);
  mdc.SelectObject(*pic1);
  TRect r=mdc.GetClipBox();
  TBrush b(TColor::White);
  TPen p(TColor::White,1,PS_SOLID);
  mdc.SelectObject(p);
  mdc.SelectObject(b);
  mdc.Rectangle(r);
  mdc.BitBlt(0,0,pic->Width(),pic->Height(),dc,0,0);
  delete pic;
  pic=pic1;
  dc.BitBlt(0,0,w,h,mdc,0,0);
  Invalidate();
  return 1;
}

void TWndw::CmNew()
{
strcpy(Buf.file,"");
ClientWnd->PostMessage(WM_NEW,0,0);
}

void TWndw::CmSave()
{
if (strlen(Buf.file)!=0) ClientWnd->PostMessage(WM_SAVE,0,0); else
if	(TFileSaveDialog(this,*FileData,0,"Saving bitmap file").DoExecute()==IDOK)
	{
	Buf.file=new char[80];
	strcpy(Buf.file,FileData->FileName);
	ClientWnd->PostMessage(WM_SAVE,0,0);
	}
}

void TWndw::CmSaveAs()
{
if	(TFileSaveDialog(this,*FileData,0,"Saving bitmap file as...").DoExecute()==IDOK)
	{
	Buf.file=new char[80];
	strcpy(Buf.file,FileData->FileName);
	ClientWnd->PostMessage(WM_SAVE,0,0);
	}
}

void TWndw::CmOpen()
{
if (TFileOpenDialog(this,*FileData,0,"Opening bitmap file").Execute()==IDOK)
	{
	Buf.file=new char[80];
	strcpy(Buf.file,FileData->FileName);
	ClientWnd->PostMessage(WM_OPEN,0,0);
	}
}


//   -
LRESULT TCWndw::WmChangeP(WPARAM Id,LPARAM)
{
idp=Id;
return 1;
}

LRESULT TCWndw::WmNew(WPARAM,LPARAM)
{
  TClientDC dc(HWindow);
  TBrush b(TColor::White);
  TPen p(TColor::White,1,PS_SOLID);
  TRect rrr=dc.GetClipBox();
  TMemoryDC mdc(dc);
  mdc.SelectObject(*pic);
  mdc.SelectObject(p);
  mdc.SelectObject(b);
  mdc.Rectangle(rrr);
  dc.BitBlt(0,0,rrr.Width(),rrr.Height(),mdc,0,0);
  Invalidate();
}

LRESULT TCWndw::WmSave(WPARAM,LPARAM)
{
	int bytePerLine = ((pic->Width() *24 + 31) / 32) * 4;
	int bytePerImage = bytePerLine*pic->Height();
	FILE *f=fopen(Buf.file,"wb");
	TClientDC dc(HWindow);
	TMemoryDC mdc(dc);
	mdc.SelectObject(*pic);
//	mdc.BitBlt(1,1,pic->Width(),pic->Height(),dc,0,0);
	BITMAPFILEHEADER* fheader=new BITMAPFILEHEADER;
	fheader->bfType=19778;
	fheader->bfSize=sizeof(BITMAPINFOHEADER)+sizeof(BITMAPFILEHEADER)+bytePerImage;
	fheader->bfReserved1=0;
	fheader->bfReserved2=0;
	fheader->bfOffBits=54;//sizeof(BITMAPINFOHEADER)+sizeof(BITMAPFILEHEADER);
	fwrite(fheader,sizeof(BITMAPFILEHEADER),1,f);
	BITMAPINFOHEADER* iheader=new BITMAPINFOHEADER;

	iheader->biSize=sizeof(BITMAPINFOHEADER);
	iheader->biWidth=pic->Width();
	iheader->biHeight=pic->Height();
	iheader->biPlanes=1;
	iheader->biBitCount=24;
	iheader->biCompression=BI_RGB;
	iheader->biSizeImage=bytePerImage;
	iheader->biXPelsPerMeter=2834;
	iheader->biYPelsPerMeter=2834;
	iheader->biClrUsed=0;
	iheader->biClrImportant=0;
	fwrite(iheader,sizeof(BITMAPINFOHEADER),1,f);
	unsigned char  *imageData;
	imageData=(unsigned char*)malloc(bytePerImage);
	TColor col;
	BITMAPINFO BI;
	BI.bmiHeader=*iheader;
	mdc.GetDIBits(*pic,0,pic->Height(),imageData,BI,DIB_RGB_COLORS);
	fwrite(imageData,bytePerImage,1,f);
	fclose(f);
	delete fheader,iheader;
	free(imageData);
	delete imageData;

return 1;
}

//   
LRESULT TCWndw::WmOpen(WPARAM,LPARAM)
{
	FILE* f=fopen(Buf.file,"r");
	BITMAPFILEHEADER* fheader=new BITMAPFILEHEADER;
	fread(fheader, sizeof(BITMAPFILEHEADER), 1, f);
	BITMAPINFOHEADER* iheader=new BITMAPINFOHEADER;
	fread(iheader, sizeof(BITMAPINFOHEADER), 1, f);
	if (iheader->biBitCount==8||iheader->biBitCount==4||iheader->biBitCount==1)
	{
		fclose(f);
		TDib DIB(Buf.file);
		TClientDC dc(HWindow);
		TMemoryDC mdc(dc);
		delete pic;
		pic=new TBitmap(DIB,0);
		mdc.SelectObject(*pic);
		dc.BitBlt(1,1,pic->Width(),pic->Height(),mdc,0,0);
	}
	if (iheader->biBitCount==24)
	{
		fseek(f,fheader->bfOffBits,SEEK_SET);
		TClientDC dc(HWindow);
		delete pic;
		pic=new TBitmap(dc,iheader->biWidth,iheader->biHeight,true);
		TMemoryDC mdc(dc);
		mdc.SelectObject(*pic);
		unsigned char *imageData;
		int g=iheader->biWidth%4;
		imageData=(unsigned char *)malloc((iheader->biWidth+g)*iheader->biHeight*24);
		fread(imageData,1,(iheader->biWidth+g)*iheader->biHeight*24,f);
		BITMAPINFO BI;
		BI.bmiHeader=*iheader;
		mdc.SetDIBits(*pic,0,iheader->biHeight,imageData,BI,DIB_RGB_COLORS);
		dc.BitBlt(0,0,pic->Width(),pic->Height(),mdc,0,0);

		fclose(f);
		free(imageData);
		delete imageData;
	}
	itoa(pic->Width(),Buf1.width,10);
	itoa(pic->Height(),Buf1.height,10);
	Invalidate();
	delete iheader,fheader;
	return 1;


}


void TCWndw::Paint(TDC&DC,BOOL,TRect&)
{
  TBrush *b=new TBrush(TColor::LtGray);
  TPen *p=new TPen(TColor::LtGray,1,PS_SOLID);
  DC.SelectObject(*b);
  DC.SelectObject(*p);
  TRect r=DC.GetClipBox();
  DC.Rectangle(r);

  TMemoryDC mdc(DC);
  mdc.SelectObject(*pic);
  DC.BitBlt(0,0,pic->Width(),pic->Height(),mdc,0,0);
  delete b,p;
  b=new TBrush(TColor::LtRed);
  p=new TPen(TColor::LtRed,1,PS_SOLID);
  DC.SelectObject(*b);
  DC.SelectObject(*p);
  int x,y;
  x=pic->Width();
  y=pic->Height()/2;
  DC.Rectangle(x,y,x+2,y+2);
  x=pic->Width()/2;
  y=pic->Height();
  DC.Rectangle(x,y,x+2,y+2);
  x=pic->Width();
  y=pic->Height();
  DC.Rectangle(x,y,x+2,y+2);
  delete b,p;
}


//    - 
void TCWndw::EvLButtonDown(UINT,TPoint&point)
{
//char *c=new char[2];
//itoa(idp,c,10);
//MessageBox(c,"",MB_OK);
//Attr.H=10;
//  TClientDC dc(HWindow);
//  TMemoryDC mdc(dc);
//  mdc.SelectObject(*pic);
  if (idp==4)
  {
	 TClientDC dc(HWindow);
	 TMemoryDC mdc(dc);
	 mdc.SelectObject(*pic);
	 mdc.SelectObject(TBrush(Buf.pal[32]));
	 mdc.ExtFloodFill(point,dc.GetPixel(point),FLOODFILLSURFACE);
	 dc.BitBlt(0,0,pic->Width(),pic->Height(),mdc,0,0);
  }
  else
  if (idp==6)
  {
	 TClientDC dc(HWindow);
	 Buf.pal[32]=dc.GetPixel(point);
	 Parent->Invalidate();
  }
  else
  {
	 pp=point;
	 pressed=1;
	 SetCapture();
  }
}


//    - 
void TCWndw::EvLButtonUp(UINT,TPoint&point)
{
  TClientDC dc(HWindow);
  TMemoryDC mdc(dc);
  TRect r;
  r=dc.GetClipBox();
  mdc.SelectObject(*pic);
  int w,h;
  if (pic->Width()<=r.Width()) w=pic->Width(); else w=r.Width();
  if (pic->Height()<=r.Height()) h=pic->Height(); else h=r.Height();
  mdc.BitBlt(0,0,w,h,dc,0,0);
  pressed=0;
  ReleaseCapture();
}




//    - 
void TCWndw::EvRButtonDown(UINT,TPoint&point)
{
//  TClientDC dc(HWindow);
//  TMemoryDC mdc(dc);
//  mdc.SelectObject(*pic);
 if (idp==4)
  {
	 TClientDC dc(HWindow);
	 TMemoryDC mdc(dc);
	 mdc.SelectObject(*pic);
	 mdc.SelectObject(TBrush(Buf.pal[33]));
	 mdc.ExtFloodFill(point,dc.GetPixel(point),FLOODFILLSURFACE);
	 dc.BitBlt(0,0,pic->Width(),pic->Height(),mdc,0,0);
  }
  else
  if (idp==6)
  {
	 TClientDC dc(HWindow);
	 Buf.pal[33]=dc.GetPixel(point);
	 Parent->Invalidate();
  }
  else
  {
  pp=point;
  pressed=2;
  SetCapture();
  }
}



//    - 
void TCWndw::EvRButtonUp(UINT,TPoint&point)
{
  TClientDC dc(HWindow);
  TMemoryDC mdc(dc);
  TRect r;
  r=dc.GetClipBox();
  mdc.SelectObject(*pic);
  int w,h;
  if (pic->Width()<=r.Width()) w=pic->Width(); else w=r.Width();
  if (pic->Height()<=r.Height()) h=pic->Height(); else h=r.Height();
  mdc.BitBlt(0,0,w,h,dc,0,0);
  pressed=0;
  ReleaseCapture();
}



// 
void TCWndw::EvMouseMove(UINT,TPoint&point)
{
  if (pressed>0)
  {
	 TClientDC dc(HWindow);
	 TMemoryDC mdc(dc);
	 TBitmap *pic1=new TBitmap(dc,pic->Width(),pic->Height(),false);
	 mdc.SelectObject(*pic1);
	 mdc.BitBlt(0,0,pic->Width(),pic->Height(),dc,0,0);
	 Paint(mdc,0,mdc.GetClipBox());
	 mdc.SelectObject(TPen(Buf.pal[32+pressed-1],Buf.line,PS_SOLID));
		if (idp==1)
		{
		  mdc.MoveTo(pp);
		  mdc.LineTo(point);
		}
		if (idp==2)
		{
		  if (Buf.style==0)
		  {
			 mdc.MoveTo(pp);
			 mdc.LineTo(pp.x,point.y);
			 mdc.LineTo(point);
			 mdc.LineTo(point.x,pp.y);
			 mdc.LineTo(pp);
		  }
		  else
		  {
			 mdc.SelectObject(TBrush(Buf.pal[33-pressed+1]));
			 mdc.SelectObject(TPen(Buf.pal[32+pressed-1],Buf.line,PS_SOLID));
			 mdc.Rectangle(pp,point);
		  }
		}
		if (idp==3)
		{
		  mdc.SelectObject(*pic);
		  mdc.SelectObject(TBrush(Buf.pal[33]));
		  mdc.SelectObject(TPen(Buf.pal[33],1,PS_SOLID));
		  mdc.Rectangle(point.x,point.y,point.x+10,point.y+10);
		}
		if (idp==5)
		{
		  mdc.SelectObject(*pic);
		  mdc.MoveTo(pp);
		  pp=point;
		  mdc.LineTo(point);
		}
		if (idp==7)
		{
		  mdc.SelectObject(TBrush(Buf.pal[33-pressed+1]));
		  mdc.SelectObject(TPen(Buf.pal[32+pressed-1],Buf.line,PS_SOLID));
		  if (Buf.style==0) mdc.SelectObject(TBrush((HBRUSH) GetStockObject(NULL_BRUSH)));
		  mdc.Ellipse(pp,point);
		}
		if (idp==8)
		{
		  mdc.SelectObject(TPen(Buf.pal[32+pressed-1],5,PS_SOLID));
		  mdc.SelectObject(*pic);
		  mdc.MoveTo(pp);
		  pp=point;
		  mdc.LineTo(point);
		}

	 dc.BitBlt(0,0,pic->Width(),pic->Height(),mdc,0,0);
	 delete pic1;
  }
}








//   
void TApp::InitMainWindow()
{
  TWindow *client = new TCWndw (0, 0);
  TDecoratedFrame *frame = new TWndw (0," ", client);
  SetMainWindow(frame);
}

// 
int OwlMain(int,char *[])
{
  return TApp().Run();
}